commit cce32afc7a36c42542cf4df0e140fffed22878bf
Author: freddy77 <freddy77>
Date:   Wed Aug 4 11:01:34 2010 +0000

    simplify odbc_populate_ird

diff --git a/ChangeLog b/ChangeLog
index 74ce2cd..3672189 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Aug  4 13:01:18 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/odbc_util.c: simplify odbc_populate_ird
+
 Wed Aug  4 10:04:33 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c src/odbc/unittests/describecol.in:
 	- fix macro for odbc_set_sql_type_info
@@ -2817,4 +2820,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3108 2010/08/04 08:04:48 freddy77 Exp $
+$Id: ChangeLog,v 1.3109 2010/08/04 11:01:34 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0359783..9c0fb75 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -61,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.550 2010/08/04 06:55:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.551 2010/08/04 11:01:34 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -3010,16 +3010,6 @@ odbc_populate_ird(TDS_STMT * stmt)
 		if (!tds_dstr_copyn(&drec->sql_desc_label, col->column_name, col->column_namelen))
 			return SQL_ERROR;
 
-		switch (drec->sql_desc_concise_type) {
-		case SQL_WCHAR:
-		case SQL_WVARCHAR:
-		case SQL_WLONGVARCHAR:
-			drec->sql_desc_length = col->on_server.column_size / 2;
-			break;
-		default:
-			drec->sql_desc_length = col->on_server.column_size;
-			break;
-		}
 		odbc_set_sql_type_info(col, drec, stmt->dbc->env->attr.odbc_version);
 
 		if (!col->table_column_name) {
@@ -3082,23 +3072,10 @@ odbc_populate_ird(TDS_STMT * stmt)
 		drec->sql_desc_unnamed = tds_dstr_isempty(&drec->sql_desc_name) ? SQL_UNNAMED : SQL_NAMED;
 		/* TODO use is_nullable_type ?? */
 		drec->sql_desc_nullable = col->column_nullable ? SQL_TRUE : SQL_FALSE;
-		if (drec->sql_desc_concise_type == SQL_NUMERIC) {
+		if (drec->sql_desc_concise_type == SQL_NUMERIC)
 			drec->sql_desc_num_prec_radix = 10;
-			drec->sql_desc_octet_length = col->column_prec + 2;
-		} else {
-			SQLLEN len; 
-
+		else
 			drec->sql_desc_num_prec_radix = 0;
-			if (type == SYBMONEY)
-				len = 21;
-			else if (type == SYBMONEY4)
-				len = 12;
-			else if (drec->sql_desc_type == SQL_DATETIME)
-				len = sizeof(TIMESTAMP_STRUCT);
-			else
-				len = col->on_server.column_size;
-			drec->sql_desc_octet_length = len;
-		}
 
 		drec->sql_desc_octet_length_ptr = NULL;
 		switch (type) {
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 440d5df..0056785 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.123 2010/08/04 08:04:48 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.124 2010/08/04 11:01:34 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -846,25 +846,26 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 	return; \
 	} while(0)
 #define SET_INFO2(type, prefix, suffix, len) do { \
-	drec->sql_desc_length = len; \
+	drec->sql_desc_length = (len); \
 	SET_INFO(type, prefix, suffix); \
 	} while(0)
 
-	/* FIXME finish, support for N type (nvarchar) */
+	drec->sql_desc_octet_length = drec->sql_desc_length = col->on_server.column_size;
+
 	switch (tds_get_conversion_type(col->column_type, col->column_size)) {
 	case XSYBCHAR:
 	case SYBCHAR:
 		if (col->on_server.column_type == XSYBNCHAR)
-			SET_INFO("nchar", "'", "'");
+			SET_INFO2("nchar", "'", "'", col->on_server.column_size / 2);
 		SET_INFO("char", "'", "'");
 	case XSYBVARCHAR:
 	case SYBVARCHAR:
 		if (col->on_server.column_type == SYBNVARCHAR || col->on_server.column_type == XSYBNVARCHAR)
-			SET_INFO("nvarchar", "'", "'");
+			SET_INFO2("nvarchar", "'", "'", col->on_server.column_size / 2);
 		SET_INFO("varchar", "'", "'");
 	case SYBTEXT:
 		if (col->on_server.column_type == SYBNTEXT)
-			SET_INFO("ntext", "'", "'");
+			SET_INFO2("ntext", "'", "'", col->on_server.column_size / 2);
 		SET_INFO("text", "'", "'");
 	case SYBBIT:
 	case SYBBITN:
@@ -885,12 +886,16 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 	case SYBFLT8:
 		SET_INFO2("float", "", "", odbc_ver == SQL_OV_ODBC3 ? 53 : 15);
 	case SYBMONEY:
+		drec->sql_desc_octet_length = 21;
 		SET_INFO2("money", "$", "", 19);
 	case SYBMONEY4:
+		drec->sql_desc_octet_length = 12;
 		SET_INFO2("money", "$", "", 10);
 	case SYBDATETIME:
+		drec->sql_desc_octet_length = sizeof(TIMESTAMP_STRUCT);
 		SET_INFO2("datetime", "'", "'", 23);
 	case SYBDATETIME4:
+		drec->sql_desc_octet_length = sizeof(TIMESTAMP_STRUCT);
 		SET_INFO2("datetime", "'", "'", 16);
 	case SYBBINARY:
 		/* handle TIMESTAMP using usertype */
@@ -902,8 +907,10 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 	case SYBVARBINARY:
 		SET_INFO("varbinary", "0x", "");
 	case SYBNUMERIC:
+		drec->sql_desc_octet_length = col->column_prec + 2;
 		SET_INFO2("numeric", "", "", col->column_prec);
 	case SYBDECIMAL:
+		drec->sql_desc_octet_length = col->column_prec + 2;
 		SET_INFO2("decimal", "", "", col->column_prec);
 	case SYBINTN:
 	case SYBDATETIMN:

